'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _lodash = require('lodash');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var POSTFIXES, _serializeDates;

POSTFIXES = ['At', 'Date', 'Till', 'On'];

_serializeDates = function serializeDates(entity) {
  var factory = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (value) {
    return value.toISOString();
  };

  var key, preparedEntity, value;
  preparedEntity = entity instanceof Array ? [] : {};
  for (key in entity) {
    value = entity[key];
    if (POSTFIXES.some(function (p) {
      return RegExp('\\w+' + p + '$').test(key);
    }) && (value instanceof _moment2.default || value instanceof Date)) {
      value = factory(value);
    } else if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value !== null) {
      value = _serializeDates(value);
    }
    (0, _lodash.set)(preparedEntity, key, value);
  }
  return preparedEntity;
};

exports.default = _serializeDates;

